// /////////////////////////////////////////////////////////////////////////
// C++ code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#include "../inc/lfsr_apb_wrapper.hpp"


void lfsr_apb_wrapper::hif_cone_lfsr_0_linear_feedback()
{
    hif_cone_out_partial_sig();
    lfsr_0_linear_feedback = !static_cast< bool >( static_cast< bool >( static_cast<
         uint8_t >( out_partial_sig_sig_var >> uint8_t(3U) ) & uint8_t(1U) ) ^ static_cast<
         bool >( static_cast< uint8_t >( out_partial_sig_sig_var >> uint8_t(7U)
         ) & uint8_t(1U) ) );
}


void lfsr_apb_wrapper::hif_cone_prdata_partial0()
{
    hif_cone_out_partial_sig();
    prdata_partial0 = out_partial_sig_sig_var;
}


void lfsr_apb_wrapper::hif_cone_out_partial_sig()
{
    if (old_out_partial_sig != out_partial_sig)
    {
        old_out_partial_sig = out_partial_sig;
        out_partial_sig_sig_var = old_out_partial_sig;
    }
}



lfsr_apb_wrapper::lfsr_apb_wrapper() :
    pwdata_old(0UL),
    pwrite_old(false),
    penable_old(false),
    psel_old(false),
    paddr_old(0UL),
    presetn_old(false),
    pclk_old(false),
    hif_a2t_data(
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr),
    prdata_var_0(0UL),
    prdata_partial0(uint8_t(0U)),
    out_partial_sig(uint8_t(0U)),
    old_out_partial_sig(uint8_t(0U)),
    out_partial_sig_sig_var(uint8_t(0U)),
    lfsr_0_linear_feedback(false),
    out_partial_sig_new(uint8_t(0U)),
    process_in_queue(false),
    flag_lfsr_0_process_executed(false),
    flag_pos_pclk(false),
    flag_out_partial_sig(false)
{
}


lfsr_apb_wrapper::~lfsr_apb_wrapper()
{}


void lfsr_apb_wrapper::lfsr_0_process()
{
    if (*hif_a2t_data.presetn)
    {
        hif_cone_out_partial_sig();
        out_partial_sig_sig_var = uint8_t(0U);
        out_partial_sig_new = out_partial_sig_sig_var;
        *hif_a2t_data.pready = false;
    }
    else
    {
        hif_cone_lfsr_0_linear_feedback();
        hif_cone_out_partial_sig();
        out_partial_sig_new = static_cast< uint8_t >( static_cast< uint8_t >( static_cast<
             uint8_t >( static_cast< uint8_t >( static_cast< uint8_t >( static_cast<
             uint8_t >( static_cast< uint8_t >( static_cast< uint8_t >( static_cast<
             uint8_t >( static_cast< uint8_t >( static_cast< uint8_t >( static_cast<
             uint8_t >( static_cast< uint8_t >( static_cast< bool >( static_cast<
             uint8_t >( out_partial_sig_sig_var >> uint8_t(6U) ) & uint8_t(1U) 
            ) << uint8_t(1U) ) | static_cast< uint8_t >( static_cast< bool >( static_cast<
             uint8_t >( out_partial_sig_sig_var >> uint8_t(5U) ) & uint8_t(1U) 
            ) ) ) << uint8_t(1U) ) | static_cast< uint8_t >( static_cast< bool >
            ( static_cast< uint8_t >( out_partial_sig_sig_var >> uint8_t(4U) ) &
             uint8_t(1U) ) ) ) << uint8_t(1U) ) | static_cast< uint8_t >( static_cast<
             bool >( static_cast< uint8_t >( out_partial_sig_sig_var >> uint8_t
            (3U) ) & uint8_t(1U) ) ) ) << uint8_t(1U) ) | static_cast< uint8_t >
            ( static_cast< bool >( static_cast< uint8_t >( out_partial_sig_sig_var
             >> uint8_t(2U) ) & uint8_t(1U) ) ) ) << uint8_t(1U) ) | static_cast<
             uint8_t >( static_cast< bool >( static_cast< uint8_t >( out_partial_sig_sig_var
             >> uint8_t(1U) ) & uint8_t(1U) ) ) ) << uint8_t(1U) ) | static_cast<
             uint8_t >( static_cast< bool >( out_partial_sig_sig_var & uint8_t(1U
            ) ) ) ) << uint8_t(1U) ) | static_cast< uint8_t >( lfsr_0_linear_feedback
             );
        *hif_a2t_data.pready = true;
    }
}


void lfsr_apb_wrapper::globact_process()
{
    prdata_var_0 = *hif_a2t_data.prdata;
    hif_cone_prdata_partial0();
    prdata_var_0 = prdata_var_0 & 4294967040UL | prdata_partial0;
    *hif_a2t_data.prdata = prdata_var_0;
}


void lfsr_apb_wrapper::update_input_queue( bool synch_phase )
{
    process_in_queue = false;
    if (*hif_a2t_data.pclk != pclk_old)
    {
        pclk_old = *hif_a2t_data.pclk;
        if (*hif_a2t_data.pclk == true)
        {
            flag_pos_pclk = true;
        }
        else
        {
            flag_pos_pclk = false;
        }
        process_in_queue = true;
    }
    else
    {
        flag_pos_pclk = false;
    }
    presetn_old = *hif_a2t_data.presetn;
    paddr_old = *hif_a2t_data.paddr;
    psel_old = *hif_a2t_data.psel;
    penable_old = *hif_a2t_data.penable;
    pwrite_old = *hif_a2t_data.pwrite;
    pwdata_old = *hif_a2t_data.pwdata;
}


void lfsr_apb_wrapper::update_event_queue()
{
    process_in_queue = false;
    update_input_queue( false );
    if (flag_lfsr_0_process_executed && out_partial_sig != out_partial_sig_new)
    {
        out_partial_sig = out_partial_sig_new;
        flag_out_partial_sig = true;
        process_in_queue = true;
    }
    else
    {
        flag_out_partial_sig = false;
    }
}


void lfsr_apb_wrapper::flag_elaboration()
{
    flag_lfsr_0_process_executed = false;
    if (flag_pos_pclk)
    {
        lfsr_0_process();
        flag_lfsr_0_process_executed = true;
    }
    if (flag_out_partial_sig)
    {
        globact_process();
    }
}


void lfsr_apb_wrapper::start_of_simulation()
{
    lfsr_0_process();
    flag_lfsr_0_process_executed = true;
    globact_process();
}


void lfsr_apb_wrapper::initialize()
{
    start_of_simulation();
}




